Index: trunk/lib/FlairSensorActuator/src/SimuBldc.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimuBldc.cpp	(revision 223)
+++ trunk/lib/FlairSensorActuator/src/SimuBldc.cpp	(revision 224)
@@ -50,27 +50,4 @@
 }
 
-SimuBldc::SimuBldc(const Object *parent, string name, uint8_t motors_count,
-                   uint32_t modelId,uint32_t deviceId)
-    : Bldc(parent, name, motors_count) {
-  shmem =
-      new SharedMem(this, ShMemName(modelId, deviceId), motors_count * sizeof(float)+sizeof(Time));
-      
-  buf=(char*)malloc(motors_count * sizeof(float)+sizeof(Time));
-  if(buf==NULL) {
-    Err("error creating buffer\n");
-    return;
-  } 
-  
-  // reset values
-  float *values=(float*)buf;
-  for (int i = 0; i < motors_count; i++) values[i] = 0;
-  Time time=GetTime();
-  memcpy(buf+motors_count * sizeof(float),&time,sizeof(Time));
-
-  shmem->Write(buf, motors_count * sizeof(float)+sizeof(Time));
-  
-  SetIsReady(true);
-}
-
 SimuBldc::~SimuBldc() {
   if(buf!=NULL) free(buf);
@@ -99,14 +76,4 @@
 }
 
-void SimuBldc::GetSpeeds(float *value,Time* time) const {
-  float *values=(float*)buf;
-  shmem->Read(buf, MotorsCount() * sizeof(float)+sizeof(Time));
-  memcpy(time,buf+MotorsCount() * sizeof(float),sizeof(Time));
-
-  for (int i = 0; i < MotorsCount(); i++) {
-    value[i] = values[i];
-  }
-}
-
 } // end namespace sensor
 } // end namespace flair
Index: trunk/lib/FlairSensorActuator/src/SimuBldc.h
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimuBldc.h	(revision 223)
+++ trunk/lib/FlairSensorActuator/src/SimuBldc.h	(revision 224)
@@ -40,5 +40,5 @@
   * \brief Constructor
   *
-  * Construct a SimuBldc. Control part.
+  * Construct a SimuBldc
   *
   * \param parent parent
@@ -53,32 +53,8 @@
 
   /*!
-  * \brief Constructor
-  *
-  * Construct a SimuBldc. Simulation part.
-  *
-  * \param parent parent
-  * \param name name
-  * \param motors_count number of motors
-  * \param modelId Model id
-  * \param deviceId Bldc id of the Model
-  */
-  SimuBldc(const core::Object *parent, std::string name, uint8_t motors_count,
-           uint32_t modelId,uint32_t deviceId);
-
-  /*!
   * \brief Destructor
   *
   */
   ~SimuBldc();
-
-  /*!
-  * \brief Get motors speeds.
-  *
-  * This function should only be used for the simulation part.
-  *
-  * \param value array to store motors speeds
-  * \param time time when shared memory was written
-  */
-  void GetSpeeds(float *value,core::Time* time) const;
 
   /*!
Index: trunk/lib/FlairSensorActuator/src/SimuCamera.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimuCamera.cpp	(revision 223)
+++ trunk/lib/FlairSensorActuator/src/SimuCamera.cpp	(revision 224)
@@ -30,5 +30,4 @@
 namespace sensor {
 
-//control part
 SimuCamera::SimuCamera(string name,
                        uint16_t width, uint16_t height, uint8_t channels,
@@ -49,17 +48,4 @@
 }
 
-//simulation part
-SimuCamera::SimuCamera(const IODevice *parent, string name, uint16_t width,
-                       uint16_t height, uint8_t channels, uint32_t modelId,uint32_t deviceId)
-    : Thread(parent, name, 0), Camera(parent,name) {
-
-  buf_size = width * height * channels+sizeof(Time);
-  
-  shmem = new SharedMem((Thread *)this,ShMemName(modelId, deviceId),
-                        buf_size, SharedMem::Type::producerConsumer);
-  shmemReadBuf=NULL;
-  
-  SetIsReady(true);
-}
 
 SimuCamera::~SimuCamera() {
Index: trunk/lib/FlairSensorActuator/src/SimuCamera.h
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimuCamera.h	(revision 223)
+++ trunk/lib/FlairSensorActuator/src/SimuCamera.h	(revision 224)
@@ -35,5 +35,5 @@
   * \brief Constructor
   *
-  * Construct a SimuCamera. Control part.
+  * Construct a SimuCamera.
 	* It will be child of the FrameworkManager.
   *
@@ -50,20 +50,4 @@
              uint8_t priority);
 
-  /*!
-  * \brief Constructor
-  *
-  * Construct a SimuCamera. Simulation part.\n
-  * The Thread of this class should not be run.
-  *
-  * \param parent parent
-  * \param name name
-  * \param width width
-  * \param height height
-  * \param channels number of channels
-  * \param modelId Model id
-  * \param deviceId Camera id of the Model
-  */
-  SimuCamera(const core::IODevice *parent, std::string name, uint16_t width,
-             uint16_t height, uint8_t channels, uint32_t modelId,uint32_t deviceId);
 
   /*!
Index: trunk/lib/FlairSensorActuator/src/SimuGps.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimuGps.cpp	(revision 223)
+++ trunk/lib/FlairSensorActuator/src/SimuGps.cpp	(revision 224)
@@ -18,5 +18,4 @@
 #include "SimuGps.h"
 #include <FrameworkManager.h>
-#include <GeoCoordinate.h>
 #include <GpsData.h>
 #include <SharedMem.h>
@@ -57,14 +56,4 @@
 
 
-SimuGps::SimuGps(const IODevice *parent, string name, uint32_t modelId,uint32_t deviceId)
-    : NmeaGps(parent, name), Thread(parent, name, 0) {
-  dataRate = NULL;
-
-  shmem = new SharedMem((Thread *)this,ShMemName(modelId, deviceId),
-                        sizeof(gps_states_t));
-  
-  SetIsReady(true);
-}
-
 SimuGps::~SimuGps() {
   SafeStop();
@@ -76,23 +65,4 @@
   dev_name << "simu" <<  modelId << "_gps_" << deviceId;
   return dev_name.str().c_str();
-}
-
-void SimuGps::UpdateFrom(const io_data *data) {
-  if (data != NULL) {
-    Matrix *input = (Matrix *)data;
-    gps_states_t state;
-
-    input->GetMutex();
-    //simulator is ned, convert it to enu
-    //TODO: put simulator in enu?
-    state.e = input->ValueNoMutex(5, 0);//y simulator
-    state.n = input->ValueNoMutex(4, 0);//x simulator
-    state.u = -input->ValueNoMutex(6, 0);//z simulator
-    state.ve = input->ValueNoMutex(11, 0);//vy simulator
-    state.vn = input->ValueNoMutex(10, 0);//vx simulator
-    input->ReleaseMutex();
-
-    shmem->Write((char *)&state, sizeof(gps_states_t));
-  }
 }
 
Index: trunk/lib/FlairSensorActuator/src/SimuGps.h
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimuGps.h	(revision 223)
+++ trunk/lib/FlairSensorActuator/src/SimuGps.h	(revision 224)
@@ -38,5 +38,5 @@
   * \brief Constructor
   *
-  * Construct a simulation GPS. Control part.
+  * Construct a simulation GPS
   * It will be child of the FrameworkManager.
 	* 
@@ -49,17 +49,4 @@
   SimuGps(std::string name,
           NmeaGps::NMEAFlags_t NMEAFlags, uint32_t modelId,uint32_t deviceId,uint8_t priority);
-
-  /*!
-  * \brief Constructor
-  *
-  * Construct a simulation GPS. Simulation part.\n
-  * The Thread of this class should not be run.
-  *
-  * \param parent parent
-  * \param name name
-  * \param modelId Model id
-  * \param deviceId Gps id of the Model
-  */
-  SimuGps(const core::IODevice *parent, std::string name, uint32_t modelId,uint32_t deviceId);
 
   /*!
@@ -77,5 +64,5 @@
   * \param data data from the parent to process
   */
-  void UpdateFrom(const core::io_data *data);
+  void UpdateFrom(const core::io_data *data){};
 
   /*!
Index: trunk/lib/FlairSensorActuator/src/SimuImu.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimuImu.cpp	(revision 223)
+++ trunk/lib/FlairSensorActuator/src/SimuImu.cpp	(revision 224)
@@ -34,5 +34,4 @@
 namespace sensor {
 
-//Construct a SimuImu. Control part.
 SimuImu::SimuImu(string name, uint32_t modelId,uint32_t deviceId,
                  uint8_t priority)
@@ -42,14 +41,4 @@
   ahrsData = new AhrsData((Imu *)this);
   
-  shmem = new SharedMem((Thread *)this, ShMemName(modelId, deviceId),
-                        sizeof(imu_states_t));
-  SetIsReady(true);
-}
-
-//Construct a SimuImu. Simulation part.
-SimuImu::SimuImu(const IODevice *parent, string name, uint32_t modelId,uint32_t deviceId)
-    : Imu(parent,name), Thread(parent, name, 0) {
-  dataRate = NULL;
-
   shmem = new SharedMem((Thread *)this, ShMemName(modelId, deviceId),
                         sizeof(imu_states_t));
@@ -66,29 +55,4 @@
   dev_name << "simu" <<  modelId << "_imu_" << deviceId;
   return dev_name.str().c_str();
-}
-
-void SimuImu::UpdateFrom(const io_data *data) {
-  if (data != NULL) {
-    Matrix *input = (Matrix *)data;
-    imu_states_t state;
-
-    input->GetMutex();
-    state.q0 = input->ValueNoMutex(0, 0);
-    state.q1 = input->ValueNoMutex(1, 0);
-    state.q2 = input->ValueNoMutex(2, 0);
-    state.q3 = input->ValueNoMutex(3, 0);
-    state.wx = input->ValueNoMutex(7, 0);
-    state.wy = input->ValueNoMutex(8, 0);
-    state.wz = input->ValueNoMutex(9, 0);
-    state.ax = input->ValueNoMutex(13, 0);
-    state.ay = input->ValueNoMutex(14, 0);
-    state.az = input->ValueNoMutex(15, 0);
-    state.mx = input->ValueNoMutex(16, 0);
-    state.my = input->ValueNoMutex(17, 0);
-    state.mz = input->ValueNoMutex(18, 0);
-    input->ReleaseMutex();
-
-    shmem->Write((char *)&state, sizeof(imu_states_t));
-  }
 }
 
Index: trunk/lib/FlairSensorActuator/src/SimuImu.h
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimuImu.h	(revision 223)
+++ trunk/lib/FlairSensorActuator/src/SimuImu.h	(revision 224)
@@ -38,5 +38,5 @@
   * \brief Constructor
   *
-  * Construct a SimuImu. Control part.
+  * Construct a SimuImu.
 	* It will be child of the FrameworkManager.
   *
@@ -48,17 +48,4 @@
   SimuImu(std::string name,
           uint32_t modelId,uint32_t deviceId, uint8_t priority);
-
-  /*!
-  * \brief Constructor
-  *
-  * Construct a SimuImu. Simulation part.\n
-  * The Thread of this class should not be run.
-  *
-  * \param parent parent
-  * \param name name
-  * \param modelId Model id
-  * \param deviceId Imu id of the Model
-  */
-  SimuImu(const core::IODevice *parent, std::string name, uint32_t modelId,uint32_t deviceId);
 
   /*!
@@ -84,5 +71,5 @@
   * \param data data from the parent to process
   */
-  void UpdateFrom(const core::io_data *data);
+  void UpdateFrom(const core::io_data *data){};
 
   typedef struct {
Index: trunk/lib/FlairSensorActuator/src/SimuLaser.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimuLaser.cpp	(revision 223)
+++ trunk/lib/FlairSensorActuator/src/SimuLaser.cpp	(revision 224)
@@ -17,5 +17,4 @@
 #include "SimuLaser.h"
 #include <FrameworkManager.h>
-#include <ImuData.h>
 #include <SpinBox.h>
 #include <GroupBox.h>
@@ -37,13 +36,4 @@
   data_rate =
       new SpinBox(GetGroupBox()->NewRow(), "data rate", " Hz", 1, 500, 1, 50);
-
-  shmem = new SharedMem((Thread *)this, ShMemName(modelId, deviceId),
-                        360 * sizeof(float));
-  SetIsReady(true);
-}
-
-SimuLaser::SimuLaser(const IODevice *parent, string name, uint32_t modelId,uint32_t deviceId)
-    : Thread(parent, name, 0), LaserRangeFinder(parent, name) {
-  data_rate = NULL;
 
   shmem = new SharedMem((Thread *)this, ShMemName(modelId, deviceId),
Index: trunk/lib/FlairSensorActuator/src/SimuLaser.h
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimuLaser.h	(revision 223)
+++ trunk/lib/FlairSensorActuator/src/SimuLaser.h	(revision 224)
@@ -37,6 +37,5 @@
   * \brief Constructor
   *
-  * Construct a SimuUs. Control part.
-	* It will be child of the FrameworkManager.
+  * Construct a SimuUs.
   *
   * \param name name
@@ -47,17 +46,4 @@
   SimuLaser(std::string name,
             uint32_t modelId,uint32_t deviceId, uint8_t priority);
-
-  /*!
-  * \brief Constructor
-  *
-  * Construct a SimuUs. Simulation part.\n
-  * The Thread of this class should not be run.
-  *
-  * \param parent parent
-  * \param name name
-  * \param modelId Model id
-  * \param deviceId LaserRangeFinder id of the Model
-  */
-  SimuLaser(const core::IODevice *parent, std::string name, uint32_t modelId,uint32_t deviceId);
 
   /*!
Index: trunk/lib/FlairSensorActuator/src/SimuUs.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimuUs.cpp	(revision 223)
+++ trunk/lib/FlairSensorActuator/src/SimuUs.cpp	(revision 224)
@@ -17,5 +17,4 @@
 #include "SimuUs.h"
 #include <FrameworkManager.h>
-#include <ImuData.h>
 #include <SpinBox.h>
 #include <GroupBox.h>
@@ -41,14 +40,4 @@
   shmem = new SharedMem((Thread *)this, ShMemName(modelId, deviceId), sizeof(float));
 
-  SetIsReady(true);
-}
-
-//simulation part
-SimuUs::SimuUs(const IODevice *parent, string name,uint32_t modelId,uint32_t deviceId)
-    : Thread(parent, name, 0), UsRangeFinder(parent,name) {
-  data_rate = NULL;
-
-  shmem = new SharedMem((Thread *)this, ShMemName(modelId, deviceId), sizeof(float));
-  
   SetIsReady(true);
 }
Index: trunk/lib/FlairSensorActuator/src/SimuUs.h
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimuUs.h	(revision 223)
+++ trunk/lib/FlairSensorActuator/src/SimuUs.h	(revision 224)
@@ -37,5 +37,5 @@
   * \brief Constructor
   *
-  * Construct a SimuUs. Control part.
+  * Construct a SimuUs.
 	* It will be child of the FrameworkManager.
   *
@@ -47,17 +47,4 @@
   SimuUs(std::string name,
          uint32_t modelId,uint32_t deviceId, uint8_t priority);
-
-  /*!
-  * \brief Constructor
-  *
-  * Construct a SimuUs. Simulation part.\n
-  * The Thread of this class should not be run.
-  *
-  * \param parent parent
-  * \param name name
-  * \param modelId Model id
-  * \param deviceId UsRangeFinder id of the Model
-  */
-  SimuUs(const core::IODevice *parent, std::string name, uint32_t modelId,uint32_t deviceId);
 
   /*!