Index: trunk/demos/CircleFollower/uav/src/main.cpp
===================================================================
--- trunk/demos/CircleFollower/uav/src/main.cpp	(revision 231)
+++ trunk/demos/CircleFollower/uav/src/main.cpp	(revision 232)
@@ -75,5 +75,5 @@
         cmd.add( portArg );
 
-        ValueArg<string> addressArg("a","address","addresse station sol",true,"127.0.0.1","string");
+        ValueArg<string> addressArg("a","address","adresse station sol",true,"127.0.0.1","string");
         cmd.add( addressArg );
 
Index: trunk/lib/FlairSensorActuator/src/VrpnClient.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/VrpnClient.cpp	(revision 231)
+++ trunk/lib/FlairSensorActuator/src/VrpnClient.cpp	(revision 232)
@@ -20,5 +20,4 @@
 #include <TabWidget.h>
 #include <Layout.h>
-#include <string.h>
 
 using std::string;
Index: trunk/lib/FlairSensorActuator/src/VrpnClient_impl.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/VrpnClient_impl.cpp	(revision 231)
+++ trunk/lib/FlairSensorActuator/src/VrpnClient_impl.cpp	(revision 232)
@@ -30,7 +30,4 @@
 #include <Quaternion.h>
 #include <Mutex.h>
-#include <string.h>
-#include <unistd.h>
-#include <limits.h>
 #include <math.h>
 
Index: trunk/tools/VrpnBridge/CMakeLists.txt
===================================================================
--- trunk/tools/VrpnBridge/CMakeLists.txt	(revision 232)
+++ trunk/tools/VrpnBridge/CMakeLists.txt	(revision 232)
@@ -0,0 +1,31 @@
+PROJECT(vrnbridge)
+cmake_minimum_required(VERSION 2.8)
+include($ENV{FLAIR_ROOT}/flair-dev/cmake-modules/GlobalCmakeFlair.cmake)
+
+if("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "x86_64")
+
+include_directories(
+	${FLAIR_INCLUDE_DIR}
+    ${CMAKE_SYSROOT}/usr/include/vrpn
+)
+
+ADD_EXECUTABLE(${PROJECT_NAME}
+    src/main.cpp
+)
+
+TARGET_LINK_LIBRARIES(${PROJECT_NAME} vrpn)
+
+INSTALL(
+	TARGETS ${PROJECT_NAME}
+	RUNTIME DESTINATION $ENV{FLAIR_ROOT}/flair-bin/tools/${ARCH_DIR}
+)
+
+SET(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
+
+else()
+    if(DEFINED CMAKE_SYSTEM_PROCESSOR_DEFAULTTUNE)
+        warn("${PROJECT_NAME} will not be built for ${CMAKE_SYSTEM_PROCESSOR_DEFAULTTUNE} architecture")
+    else()
+        warn("${PROJECT_NAME} will not be built for ${CMAKE_SYSTEM_PROCESSOR} architecture")
+    endif()
+endif()
Index: trunk/tools/VrpnBridge/src/main.cpp
===================================================================
--- trunk/tools/VrpnBridge/src/main.cpp	(revision 232)
+++ trunk/tools/VrpnBridge/src/main.cpp	(revision 232)
@@ -0,0 +1,61 @@
+//  created:    2018/03/13
+//  filename:   main.cpp
+//
+//  author:     Guillaume Sanahuja
+//              Copyright Heudiasyc UMR UTC/CNRS 7253
+//
+//  version:    $Id: $
+//
+//  purpose:    vrpn bridge, to forward it to bth for exemple
+//
+//
+/*********************************************************************/
+#include <vrpn_Connection.h>
+#include <vrpn_Forwarder.h>
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <signal.h>
+
+vrpn_Connection * server_connection;
+vrpn_Connection * client_connection;
+vrpn_StreamForwarder * forwarder;
+
+void sighandler (int signal) {
+  delete forwarder;
+  delete server_connection;
+  delete client_connection;
+  exit(0);
+}
+
+void install_handler (void) {
+  signal( SIGINT, sighandler );
+  signal( SIGKILL, sighandler );
+  signal( SIGTERM, sighandler );
+  signal( SIGPIPE, sighandler );
+}
+
+int main (int argc, char ** argv) {
+
+  int retval;
+
+  server_connection = vrpn_get_connection_by_name ("127.0.0.1:3883");
+  client_connection = vrpn_create_server_connection(3884);
+
+  forwarder = new vrpn_StreamForwarder(server_connection, "target", client_connection, "target");
+
+  retval = forwarder->forward("vrpn_Tracker Pos_Quat", "vrpn_Tracker Pos_Quat");
+  if (retval)
+    fprintf(stderr, "forwarder->forward (vrpn_Tracker Pos_Quat) failed.\n");
+    
+  retval = forwarder->forward("vrpn_Base ping_message", "vrpn_Base ping_message");
+   if (retval)
+    fprintf(stderr, "forwarder->forward (vrpn_Base ping_message) failed.\n");
+
+  install_handler();
+
+  while (1) {
+    server_connection->mainloop();
+    client_connection->mainloop();
+  }
+}